--  BackFlashed Lua --
--  Credit：
--  Toby [Maker]
--  Special Thanks:Bowlinghead,WTF[Help and Idea]
--  Enjoy!
--  Time:2020/06/07
local _parse = parse
function parse(...)
	local cmds = table.concat({...}, ' ')
	return _parse(cmds)
end

function playerpos(p)
    return player(p,'x'),player(p,'y')
end
function playermos(p)
    return player(p,'mousemapx'),player(p,'mousemapy')
end
addhook('projectile_impact','flash')
function flash(id,w,x,y,m,pt)
    function freeprojectile()
        parse('freeprojectile',pt,id)
        isflash(x,y)
        parse('sv_soundpos "weapons/g_flash.wav"',x,y)
        parse('sv_soundpos "weapons/g_flash.wav"',x,y)
    end
    if w == 54 and m== 100 then
        timer(500,'freeprojectile')
    end
end
function flashplayer(id,power)
    parse('flashplayer',id,power)
end
function distance(x1,y1,x2,y2)
	local xd = x2 - x1
	local yd = y2 - y1
	return( math.sqrt(xd*xd + yd*yd) )
end
function isflash(x,y)
    for _,p in pairs(closeplayers(x,y,360)) do
        local x1,y1 = playerpos(p)
        local x2,y2 = x,y
        local x3,y3 = playermos(p)
        local rot = math.atan2(y2 - y1, x2 - x1)
		local hit = 1
			while distance(x1,y1,x2,y2) > 4 do
				x2 = x2 - math.cos(rot) * 3
				y2 = y2 - math.sin(rot) * 3
				if (tile(math.ceil(x2 / 32) - 1,math.ceil(y2 / 32) - 1,"wall")) then
					hit = 0
				end
            end
        if hit == 1 then
            if calcu(x1,x2,x3,y1,y2,y3) <= 90 then
                flashplayer(p,100)
            else
                flashplayer(p,10)
            end
        end
    end
end

function calcu(x1,x2,x3,y1,y2,y3)
    local a = math.atan2((y2-y1),(x2-x1))
    local b = math.atan2((y3-y1),(x3-x1))
    local pi = 180/math.pi
    return math.abs(a-b)*pi
end

addhook('buy','buy_flash')
function buy_flash(p,t)
    if t == 52 then
        function removeflash()
            parse('strip',p,52)
        end
        timer(100,'removeflash')
        parse('equip',p,54)
    end
end